package com.tearabite;

public class DcMotor {
    private final Board board;
    private final int index;
    private int multiplier = 1;

    public DcMotor(Board board, int index) {
        this.board = board;
        this.index = index;
    }

    public void setPower(double power) {
        int speed = (int) (100 * power * multiplier);
        this.board.setMotor(index, speed);
    }

    public void setDirection(Direction direction) {
        this.multiplier = Direction.Reversed.equals(direction) ? -1 : 1;
    }

    public enum Direction { Forward, Reversed }
}
